using System.IO;
using Newtonsoft.Json.Linq;

namespace Props.Services.Content
{
    public class CachedContentManager<TPage> : IContentManager<TPage>
    {
        private dynamic data;
        private readonly string directory;
        private readonly string fileName;

        dynamic IContentManager<TPage>.Json
        {
            get
            {
                if (data == null) data = JValue.Parse(File.ReadAllText(Path.Combine(directory, fileName)));
                return data;
            }
        }

        public CachedContentManager(string directory = "content")
        {
            this.directory = directory;
            this.fileName = typeof(TPage).Name.Replace("Model", "") + ".json";
        }
    }
}